c*********************************************************
c
c          Zemlyanaya E.V.
c
c		HIGH ENEFRGY APPROXIMATION
c
c		TOTAL CROSS SECTIONS; HE-PHASE AND HE-POTENTIAL
c		EXTERNAL DENSITY OR SF-DENSITY 	
c     
c*********************************************************
c
      implicit real*8 (a-h,o-z)

	parameter (n  = 5001)
	
      dimension s1(n),s2(n),z(n),zz(n),rhopp(n),rhott(n),
     ^		rhoppp(n),rhottt(n)

	character file1*20,file2*20,file3*20,file4*20,file5*20,file6*20		

	pi  = 2.0d0*asin(1.0d0)
	sqpi = sqrt(pi)

	pi2 = pi*2.d0
	pi4 = pi*4.d0

	r0r0d6 = 0.658d0/6.d0

	print *,'file of parameters:'
	read (*,*) file1
	open(27,file=file1, status='old')

	read (27,*) file2
      open (21,file=file2,status='unknown')

c
c	read key0: in case key0=0 HEA phase and potential are saved
c
	read (27,*) key0

	if(key0.eq.0) then

	read (27,*) file3
      open (28,file=file3,status='unknown')
	read (27,*) file4
      open (29,file=file4,status='unknown')

	endif
c
c----------------- input parameters to be changed
c
c	a1,z1: projective; a2,z2: target	      
c

	read(27,*) app,zpp,att,ztt

	aa1 = att
	z1  = ztt
	aa2 = app
	z2  = zpp
	n1  = aa1-z1
	n2  = aa2-z2

ccc

      hc    = 197.327d0
      f938  = 931.494d0
      hc2   = hc*hc
      cm    = sqrt(aa1*aa2/(aa1+aa2))


c	nnn: number of points; rmax: length of interval	
	     
	read (27,*) nnn, rmax
	
c	ENERGY (MeV/nucleon)

	read (27,*) e

c	Read key1
c	key1=0: external density; 
c	nonzero key1: read data file for target.

	read (27,*), key1

	keyt = key1

	if(key1.eq.0)  then
	 
	read (27,*) file5
      open (23,file=file5,status='old')

	do i=1,nnn
	read (23,*) xxx, rhott(i)
	end do

	else	
	read (27,*) avtt,rbtt

      a1 = avtt
	rb  = rbtt
	rba1 = rb/a1

	rhosf0 = aa1*.75d0/pi/rb**3/(1.d0+(pi*a1/rb)**2)

	a1pi = a1*pi
	pipia1rb4 = pi*pi*a1*rb*4.d0
	a1pirb = a1*pi/rb
	endif

c	Read key2
c	key2=0: external density; 
c	nonzero key2: read data file for projectyle.
	
	read (27,*) key2

	keyp = key2

	if(key2.eq.0)  then
	read (27,*) file6
      open (25,file=file6,status='unknown')

	do i=1,nnn
	read (25,*) xxx,rhopp(i)
	end do

 	else	
	read (27,*) avpp,rbpp

	rbb = rbpp
	rba2 = rbb/a2
	a2 = avpp

	rhosf01 = aa2*.75d0/pi/rbb**3/(1.d0+(pi*a2/rbb)**2)
	a1pi1 = a2*pi
	pipia1rb41 = pi*pi*a2*rbb*4.d0
	a1pirb1 = a2*pi/rbb

	endif

c
c-----------------------------------------------------------------------
c

      rmin   = 0.001d0
	hhh  = (rmax-rmin)/(nnn-1)

	elab = e*aa2
	ecm = elab*aa1/(aa1+aa2)

	ac = z1*z2*1.44d0/2.d0/ecm

c      ck    = cm*sqrt(2.d0*f938*ecm)/hc
c      hv1   = f938* aa1*aa2/(aa1+aa2)/ck/hc2

	ampp = aa2*f938
	amtt = aa1*f938

	ck = amtt/hc*sqrt(elab*(elab+2.d0*ampp))
     ^		/sqrt((ampp+amtt)**2+2.d0*amtt*elab)

	betaa= sqrt(elab*(elab+2.d0*ampp))/(elab+ampp)
	hv1 = 1.d0/hc/betaa

	beta = betaa

c      beta =sqrt(1.d0-(938.d0/(elab/aa2+938.d0))**2)

      if(e.gt.10.d0) then
	sig12 = .1d0*(-70.67d0-18.18d0/beta+25.26d0/beta**2+113.85d0*beta)
	else
      sig12 = 100.d0*(2.73d0/((1.d0-.0553d0*e)**2+.35d0*e)+
     ^	17.63d0/((1.d0+.344d0*e)**2+6.8d0*e))
	end if
 
      sig11 = .1d0*(13.73d0-15.04d0/beta+8.76d0/beta**2+68.67d0*beta**4)	
	sig22 = sig11
	sign = (n1*n2*sig11+z1*z2*sig11+n2*z1*sig12+n1*z2*sig12)/aa1/aa2

	ckv = ck/5.0677d0/aa2
	al_pp = 0.1810d0+4.0818d0*ckv+0.3327d0*ckv*ckv
	al_nn = al_pp
	al_np = -.698d0 + 4.9762d0*ckv - 1.277d0*ckv*ckv
  
	alphann = (n1*n2*al_nn*sig11+z1*z2*al_pp*sig22+
     ^	(z1*n2+z2*n1)*al_np*sig12)/sign/aa1/aa2


c
c------------------------------------------------------------
c--------------both densities are given by SF parametrization
c------------------------------------------------------------	
c


	if(keyp.ne.0.and.keyt.ne.0) then
  
	do k=1,nnn

	bb = (k-1)*hhh+rmin
 
	b = 	ac+sqrt(bb**2+ac**2)

	do i=1,nnn
	st = (i-1)*hhh+rmin
	arg = st*b
	argw = st*bb

	apik = a1pi*st
	str = st*rb

	apik1 = a1pi1*st
	str1 = st*rbb

      aisf1 = -rhosf0*pipia1rb4/st/sinh(apik)*
     ^	(cos(str)-a1pirb*sin(str)/tanh(apik))

      aisf2 = -rhosf01*pipia1rb41/st/sinh(apik1)*
     ^	(cos(str1)-a1pirb1*sin(str1)/tanh(apik1))

	rhot = aisf1
	rhop = aisf2

	stst = st**2
	fqrho = rhop * rhot * exp(-stst*r0r0d6)

	z(i) = st*bj0(arg) * fqrho
	zz(i) = stst * sj0(argw) * fqrho

	end do

      call simpson(nnn,hhh,z,sint)
	xisf = sint /pi2 * sign

	if(key0.eq.0) then
	call simpson(nnn,hhh,zz,sint1)
	www = -sint1 /pi2/pi2 /hv1 *sign
	write (28,*) bb,www
	write (29,*) bb,xisf
	endif

	s1(k) = bb*(1.d0-exp(-xisf))

	end do

	end if


c
c------------------------------------
c------------------------------------ both densities are external
c------------------------------------	
c


	if(keyp.eq.0.and.keyt.eq.0) then
	  
	do k=1,nnn

	bb = (k-1)*hhh+rmin
 
	b  = ac+sqrt(bb**2+ac**2)

	do i=1,nnn
	st = (i-1)*hhh+rmin
	arg = st*b
	argw = st*bb

	do j=1,nnn
	rj = (j-1)*hhh+rmin
	sss = rj*rj*sj0(st*rj)

ccccc	rhott(j)   =  rhosf0*sinh(rba1)/(cosh(rba1)+cosh(rj/a1))
ccccc	rhopp(j)   =  rhosf01*sinh(rba2)/(cosh(rba2)+cosh(rj/a2))

	rhottt(j)   = rhott(j)  * sss 
	rhoppp(j)   = rhopp(j)  * sss 

	end do

	call simpson(nnn,hhh,rhottt,rhot)
	call simpson(nnn,hhh,rhoppp,rhop)

	rhot = rhot*pi4
	rhop = rhop*pi4

	stst = st**2
	fqrho = rhop * rhot * exp(-stst*r0r0d6)

	z(i) = st*bj0(arg) * fqrho
	zz(i) = stst * sj0(argw) * fqrho

	end do

      call simpson(nnn,hhh,z,sint)

	xisf = sint /pi2 * sign


	if(key0.eq.0) then
      call simpson(nnn,hhh,zz,sint1)
	www = -sint1 /pi2/pi2 /hv1 *sign
	write (28,*) bb,www
	write (29,*) bb,xisf
	endif

	s1(k) = bb*(1.d0-exp(-xisf))

	end do

	end if


c
c----------------------------------------------------------------------
c------------------target density is SF; projective density is external
c----------------------------------------------------------------------	
c


	if(keyp.eq.0.and.keyt.ne.0) then
	  
	do k=1,nnn

	bb = (k-1)*hhh+rmin
 
	b  = ac+sqrt(bb**2+ac**2)

	do i=1,nnn
	st = (i-1)*hhh+rmin
	arg = st*b
	argw = st*bb

	apik = a1pi*st
	str = st*rb

	do j=1,nnn
	rj = (j-1)*hhh+rmin
	sss = rj*rj*sj0(st*rj)

	rhoppp(j)   = rhopp(j)  * sss 

	end do

	call simpson(nnn,hhh,rhoppp,rhop)

	rhop = rhop*pi4

      aisf1 = -rhosf0*pipia1rb4/st/sinh(apik)*
     ^	(cos(str)-a1pirb*sin(str)/tanh(apik))

	rhot = aisf1


	stst = st**2
	fqrho = rhop * rhot * exp(-stst*r0r0d6)

	z(i) = st*bj0(arg) * fqrho
	zz(i) = stst * sj0(argw) * fqrho

	end do

      call simpson(nnn,hhh,z,sint)

	xisf = sint /pi2 * sign


	if(key0.eq.0) then		
      call simpson(nnn,hhh,zz,sint1)
	www = -sint1 /pi2/pi2 /hv1 *sign
	write (28,*) bb,www
	write (29,*) bb,xisf
	end if


	s1(k) = bb*(1.d0-exp(-xisf))

	end do

	end if


c
c----------------------------------------------------------------------
c------------------ projective density is SF; target density is external
c----------------------------------------------------------------------	
c


	if(keyp.ne.0.and.keyt.eq.0) then
	  
	do k=1,nnn

	bb = (k-1)*hhh+rmin
	
	b  = ac+sqrt(bb**2+ac**2)

	do i=1,nnn
	st = (i-1)*hhh+rmin
	arg = st*b
	argw = st*bb

	apik1 = a1pi1*st
	str1 = st*rbb

	do j=1,nnn
	rj = (j-1)*hhh+rmin
	sss = rj*rj*sj0(st*rj)

	rhottt(j)   = rhott(j)  * sss 

	end do

	call simpson(nnn,hhh,rhottt,rhot)

	rhot = rhot*pi4

      aisf2 = -rhosf01*pipia1rb41/st/sinh(apik1)*
     ^	(cos(str1)-a1pirb1*sin(str1)/tanh(apik1))

	rhop = aisf2

	stst = st**2
	fqrho = rhop * rhot * exp(-stst*r0r0d6)

	z(i) = st*bj0(arg) * fqrho
	zz(i) = stst * sj0(argw) * fqrho

	end do

      call simpson(nnn,hhh,z,sint)
 
	xisf = sint /pi2 * sign


	if(key0.eq.0) then	
      call simpson(nnn,hhh,zz,sint1)
	www = -sint1 /pi2/pi2 /hv1 *sign
	write (28,*) bb,www
	write (29,*) bb,xisf
	endif


	s1(k) = bb*(1.d0-exp(-xisf))

	end do

	end if


c
c--------------------------------------------------------------------
c------------------------- calculation of the total cross section
c--------------------------------------------------------------------
c

	call simpson(nnn,hhh,s1,res1)

 	sigma1 = res1*2.00*pi
          
	print *,'E, total crs:', e,sigma1/100 

	write (21,*) 'E (MeV/nucleon), sig_tot (barn), sig_n, alpha_nn='
	write (21,1000) e,sigma1/100,sign,alphann

c--------------------------------------------------------------------
c--------------------------------------------------------------------

1000  format(5(x,e13.7))

        end

ccc
ccc****************************************************************
ccc

      subroutine simpson(n,h,f,s)
      implicit real*8 (a-h,o-z)
      dimension f(n)
      s   = f(1)+4.d0*f(2)
      nm2 = n-2
      do i= 3,nm2,2
      s   = s+f(i)*2.d0+f(i+1)*4.d0
      end do
      s   = (s+f(n))*h/3.d0
      return
      END
c
c****************************************************
c
	function sj0(x)
	implicit real*8 (a-h,o-z)
	sj0 = 1.0d0
	if(x.ne.0.d0)	sj0 = sin(x)/x
	return
	end

c*
c*****************************************************************
c*
        function bj0(x)
        implicit real*8 (a-h,o-z)
        
	 if(abs(x).le.3.d0) then

c--------------------------------------- Abramovic, p.191 eq.9.4.1

       xx   = (x/3.d0)**2
       bj0  = 1.d0 - 2.2499997d0*xx + 1.2656208d0*xx**2 - 
     ^	 .3163866d0*xx**3
     ^      + .0444479d0*xx**4-.0039444d0*xx**5+.00021d0*xx**6
             else

c--------------------------------------- Abramovic, p.191,eq.9.4.3

       xx   = (3.d0/x)
       f0   = .79788456d0-.00000077d0*xx-.0055274d0*xx**2
     ^      - .00009512d0*xx**3+.00137237d0*xx**4-.00072805d0*xx**5
     ^      + .00014476d0*xx**6
       t0   = x-.78539816d0-.04166397d0*xx-.00003954d0*xx**2
     ^      + .00262573d0*xx**3-.00054125d0*xx**4-.00029333d0*xx**5
     ^      + .00013558d0*xx**6
       bj0  = x**(-.5)*f0*cos(t0)
c
      end if
	return

	end
ccc

